//leep frog produced by H.Fujii//

#include <stdio.h>	//wb_t@C̓ǂݍ

#define XMAX 100
#define TMAX 1000

//program
int main (void){
	FILE *fp;
	int i, n, t, tstep;
	double c, dt, dx, C, u[XMAX+2][TMAX+2];
	double x, x1, x2, T[5], X;
	c = 1.0;
	x1 = 0.2;
	x2 = 0.4;
	tstep = 200;

//Courant Number
	c = 0.01;
	dt = 1.0 / TMAX;
	dx = 1.0 / XMAX;
	C = c * dt / dx;
	printf ( " C = %f\n", C);

//initial condition
	for ( n = 0; n <= TMAX+1; n++ ){
		u[0][n] = 0.0;
	}
	for (n = 0; n <= 1; n++ ){
		for ( i = 0; i <= XMAX+1; i++){
			x = i * dx;
			if ( x < x1 ){
				u[i][n] = 0.0;
			}
			else if ( x <= x2 ){
				u[i][n] = 1.0;
			}
			else{
				u[i][n] = 0.0;
			}
		}
	}

//calculation
	for ( n = 1; n <= TMAX; n++ ){
		for ( i = 1; i <= XMAX; i++){
			u[i][n+1] = u[i][n-1] - C * ( u[i+1][n] - u[i-1][n] );
			u[XMAX+1][n+1] = u[XMAX][n];
		}
	}

//file output
	fp = fopen ("output.csv", "w");
	fprintf ( fp, "Courant Number = %f\n", C );
	fprintf ( fp, ",");
	for (t = 0; t < 5; t++ ){
		T[t] = t * tstep * dt;
		fprintf ( fp, "%f," ,T[t] );
	}
	fprintf (fp, "\n" );
	for ( i = 0; i <= XMAX; i++ ){
		X = i * dx;
		fprintf (fp, "%f,", X );
		for (t = 0; t < 5; t++){
			fprintf (fp, "%f,",u[i][t*tstep] );
		}
		fprintf (fp, "\n" );
	}
	fclose (fp);
	printf("END\n");
	return 0;
}
