//Ђ`XL[ produced by H.Fujii//

#include <stdio.h>

#define TMAX 250
#define XMAX 150
#define tstep 50

int main (void){
	FILE *fp;
	int i, n, t;
	double dt, dx, c, C, x, x1, x2;
	double u[XMAX+1][TMAX+2], T[5];
	c = 1.0;
	x1 = 0.2;
	x2 = 0.4;

//Courant Number 
	dt = 1.0 / TMAX;
	dx = 1.0 / XMAX;
	C = c * dt / dx;
	printf ("Courant Number = %f\n", C);

//initial condition//
	for ( n = 0; n < 2; n++){
		for ( i = 0; i <= XMAX; i++ ){
			x = i * dx;
			if ( x < x1 ){
				u[i][n] = 0.0;
			}	
			else if ( x <= x2 ){
				u[i][n] = 1.0;
			}
			else {
				u[i][n] = 0.0;
			}
		}
	}
	for ( n = 0; n <= TMAX+1; n++ ){
		u[0][n] = 0.0;
	}

	
//calculation//
	for ( n = 1; n <= TMAX; n++){
		for (i = 1; i <= XMAX; i++ ){
			u[i][n+1] = u[i-1][n-1] + (1.0 - 2.0 * C) * ( u[i][n] - u[i-1][n] );
			u[XMAX][n+1] = u[XMAX-1][n+1];
		}
	}

//file output//
	fp = fopen ( "output.csv", "w" );
	fprintf ( fp, "Courant Number = %f\n", C);
	fprintf ( fp, "," );
	for ( t = 0; t < 5; t++ ){
		T[t] = t * tstep * dt;
		fprintf ( fp, "%f,", T[t] );
	}
	fprintf (fp, "\n");
	for ( i = 0; i <= XMAX; i++ ){
		x = i * dx;
		fprintf (fp, "%f,", x);
		for ( t = 0; t < 5; t++ ){
			fprintf (fp, "%f,", u[i][t*tstep] );
		}
		fprintf (fp, "\n");
	}
	fclose (fp);
			
	return 0;
}